/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1999
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *   Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: messages.h,v 1.13 1999/03/31 17:59:54 renaud Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   PEKS - private exponent key stuff for Diffie Hellman and El Gamal
 */

#ifndef __MESSAGES_H__
#define __MESSAGES_H__


/* some magic */
#define _arg1of2(x,y) x
#define _arg2of2(x,y) y


/* extract value from error symbol */
#define errnum(sym)  (sym (_arg1of2) + 20000)
#define errstr(sym)   sym (_arg2of2)



#define PEKS_GENERIC_LIST(f) \
       f(GENERIC_MSG_1) f(GENERIC_MSG_2) f(GENERIC_MSG_3)

/* generic error symbols, not in PEKS_ERRLIST, below */
#define GENERIC_MSG_1(f)   f(1, "Message no. 1 - you should not see that text")
#define GENERIC_MSG_2(f)   f(2, "Message no. 2 - you should not see that text")
#define GENERIC_MSG_3(f)   f(3, "Message no. 3 - you should not see that text")



/* concise list of all error symbols */
#define PEKS_ERRLIST1(f)							\
	f(CANT_OPEN_KEY_RFILE) f(CANT_OPEN_KEY_WFILE) f(KEYFILE_PARSER_ERR)	\
        f(FUNCTION_ARG_ERROR) f(NO_SYMLINK_WANTED) f(REG_FILE_WANTED)		\
        f(NOT_GROUP_WRITABLE) f(NOT_WORLD_READABLE) f(NOT_GROUP_READABLE)	\
        f(KEY_FILE_EXISTS) f(CANT_EXPAND_FNAME)	f(SPOOF_ALERT)			\
	f(STORED_SERVER_KEY) f(TOO_MANY_PRIME_TRIES) f(	MODIFIED_KEY_TAG)	\
        f(LINE_PARSER_ERR) f(LINE_PARSER_CRCERR) f(LINE_PARSER_B64ERR)		\
        f(LINE_KEYLEN_UNDERFLW) f(NO_USER_NAME) f(INVALID_USER_NAME)		\
        f(NO_HOST_NAME) f(ENC_TEXT_2LONG) f(ENC_B64TEXT_ERR) f(ENC_B64EXTR_ERR)	\
        f(NO_SUCH_USER) f(FILE_IS_BUSY)

#define PEKS_ERRLIST2(f)							\
	f(PEKS_VERS_MISMATCH) f(ELGML_PAYLOAD_ERR) f(ILL_DIGST_HEADER)		\
        f(LINE_SYNTAX_ERR) f(LINE_CRC_ERR) f(DECODE_KEY_ERR)			\
        f(AUTH_HEADER_FAILED)							\
        f(SRV_SETUP_SKEY) f(SRV_CLIENT_KNOCKING) f(SRV_CLIENT_RESPERR)		\
        f(SRV_MAGIC_FAILED) f(SRV_WRONG_MAGIC) f(CLNT_MAGIC_FAILED)		\
        f(CLNT_AUTH_TERM) f(CLNT_AUTH_RESPERR) f(CLNT_AUTH_SHORTCHALL)		\
        f(CLNT_SEND_FAILED)

#define PEKS_ERRLIST3(f) f(DECODE_SRVKEY_ERR)					\
        f(CBC_RECV_NULL_BLOCK) f(CBC_RECV_LEN_2SMALL) f(CBC_RECV_LEN_2LARGE)	\
        f(CBC_RECV_LEN_NOBNDRY) f(CBC_RECV_UNEXP_EOF) f(CBC_RECV_CRCERR)	\
        f(CBC_CACHERES_BLOCKED) f(CBC_UNKNOWN_CTL) f(CBC_NULL_CTLARG)		\
        f(CBC_NOSUCH_THREADID) f(CBC_NOSUCH_COOKIE) f(CBC_CTL_SENDER_ONLY)	\
        f(CBC_CTL_RECV_ONLY) f(CBC_REC_ILL_THREADID) f(CBC_REC_NO_THREADID)	\
	f(CBC_NO_MORE_THREADS) f(CBC_ILL_THREADID) f(CBC_ILL_SUBCMD)		\
	f(CBC_UNSUPPORTED_BLEN)	f(CBC_UNSUPPORTED_KLEN)	f(PSVC_FMTSIZE_2LARGE)	\
        f(CBC_CANT_KILL_NOTOWN) f(IOST_SEND_RECV_ONLY)

#define PEKS_ERRLIST4(f)							\
        f(IOST_NO_RECV_IOLFN) f(IOST_NO_SEND_IOLFN)				\
        f(IOST_NO_RECV_CTLFN) f(IOST_NO_SEND_CTLFN) f(IOST_EEXISTS)		\
        f(PUBKEY_2SHORT_UU) f(PRVKEY_2SHORT_UU) f(CANT_SAVE_KEYS_SS)		\
        f(CANT_GEN_KEYS_S) f(CANT_READ_KEYS_SS) f(PRPC_HEADER_FAILED)		\
        f(PRPC_COMMD_ILLEGAL) f(PRPC_INIT_FAILED) f(PRPC_ALREADY_INIT)		\
        f(PRPC_INT_ARG_ERROR) f(PSVC_SIZE_2LARGE) f(PSVC_FMT_ERROR)		\
        f(PSVC_FMT_NO_TYPE) f(PSVC_NO_PROTOTYPE) f(PSVC_ILLCHAR_IN_SVC)		\
        f(PSVC_INT_ARG_ERROR)

/* peks-file.c error symbols */
#define CANT_OPEN_KEY_RFILE(f)	f(11, "Can't open key file for reading")
#define CANT_OPEN_KEY_WFILE(f)	f(12, "Can't open key file for writing")
#define KEYFILE_PARSER_ERR(f)	f(13, "Illegal lines in key file")
#define NO_SYMLINK_WANTED(f)    f(15, "File must not be a symbolic link")
#define REG_FILE_WANTED(f)      f(16, "File must be regular, neither a pipe, nor a device")
#define NOT_GROUP_WRITABLE(f)   f(17, "File must neither be world, nor group writable")
#define NOT_WORLD_READABLE(f)   f(18, "File must not be world readable")
#define NOT_GROUP_READABLE(f)   f(19, "File must neither be world, nor group readable")
#define KEY_FILE_EXISTS(f)      f(20, "Attempt to overwrite existing key file")
#define CANT_EXPAND_FNAME(f)    f(21, "Cannot expand key file name ($HOME missing ?)")
#define SPOOF_ALERT(f)          f(22, "Spoof alert: public key of sender has changed")
#define STORED_SERVER_KEY(f)    f(23, "Host key for that server has been saved")
#define MODIFIED_KEY_TAG(f)     f(24, "A special purpose key entry has been modified")
#define NO_USER_NAME(f)         f(25, "Can't determine the user name from pwd structure")
#define INVALID_USER_NAME(f)    f(26, "Illegal characters found in the user name")
#define NO_HOST_NAME(f)         f(27, "Can't determine the name of this host")
#define NO_SUCH_USER(f)         f(28, "User does not exist in data base")
#define FILE_IS_BUSY(f)         f(29, "Cannot unlock - maybe stale *.new file")

/* peks-setup.c error symbols */
#define LINE_PARSER_ERR(f)	f(31, "Syntax error in the key setup line")
#define LINE_PARSER_CRCERR(f)	f(32, "CRC error in the key setup line")
#define TOO_MANY_PRIME_TRIES(f)	f(35, "Can't generate prime/generator - tried too often") 

/* peks-handshake.c error symbols */
#define PEKS_VERS_MISMATCH(f)	f(41, "Unacceptable version string in the respose text")
#define LINE_SYNTAX_ERR(f)      f(42, "Unexpexted number of fields")
#define LINE_CRC_ERR(f)         f(43, "Crc verification ckeck failed")
#define ILL_DIGST_HEADER(f)     f(45, "Unknown passwd digest response header")

/* peks-client.c error symbols */
#define DECODE_SRVKEY_ERR(f)	f(61, "Can't decode server key message")
#define CLNT_MAGIC_FAILED(f)	f(62, "Could not send magic string to the server")
#define CLNT_SEND_FAILED(f)	f(63, "Could not send data to the server")
#define CLNT_AUTH_TERM(f)       f(65, "Server has terminated the auth handshake")
#define CLNT_AUTH_RESPERR(f)    f(66, "Server sent garbage with the auth response")
#define CLNT_AUTH_SHORTCHALL(f) f(67, "Server sent short challenge")

/* peks-server.c error symbols */
#define SRV_SETUP_SKEY(f)	f(73, "Can't setup peks server key")
#define SRV_MAGIC_FAILED(f)	f(74, "Could not read magic string from client")
#define SRV_WRONG_MAGIC(f)	f(75, "Client sent incompatible magic string")
#define SRV_CLIENT_KNOCKING(f)	f(76, "Client was knocking at the door, only")
#define SRV_CLIENT_RESPERR(f)	f(77, "Initial client response was garbage")
#define AUTH_HEADER_FAILED(f)	f(78, "Illegal auth request header sent by the client")

/* cbc-frame.c error symbols */
#define CBC_RECV_NULL_BLOCK(f)	f( 91, "Received EOF when block was expected")
#define CBC_RECV_LEN_2SMALL(f)	f( 92, "Received block length value too small")
#define CBC_RECV_LEN_2LARGE(f)	f( 93, "Received block length value exceeds limit")
#define CBC_RECV_LEN_NOBNDRY(f)	f( 94, "Received block length value not on block boundary")
#define CBC_RECV_UNEXP_EOF(f)	f( 95, "Got EOF in the middle of a block read")
#define CBC_RECV_CRCERR(f)	f( 96, "CRC error")
#define CBC_CACHERES_BLOCKED(f)	f( 97, "Need to flush cache before resizing")
#define CBC_UNKNOWN_CTL(f)	f( 98, "Unknown control request")
#define CBC_NULL_CTLARG(f)      f( 99, "Null control argument pointer not useful")
#define CBC_NOSUCH_THREADID(f)  f(100, "There is no thread with the given ID")
#define CBC_NOSUCH_COOKIE(f)    f(101, "There is no thread for the received cookie")
#define CBC_CTL_SENDER_ONLY(f)  f(102, "This control request is sender, only")
#define CBC_CTL_RECV_ONLY(f)    f(103, "This control request is receiver, only")
#define CBC_NO_MORE_THREADS(f)  f(104, "Reached maximum limit of threads, already")
#define CBC_REC_ILL_THREADID(f) f(105, "Received wrong thread id in data block")
#define CBC_REC_NO_THREADID(f)  f(106, "Threaded data block without thread id")
#define CBC_ILL_THREADID(f)     f(107, "There is no thread assigned with the id, given")
#define CBC_ILL_SUBCMD(f)       f(108, "Received unknown sub command in data block")
#define CBC_UNSUPPORTED_BLEN(f) f(109, "CBC block length not supported for that cipher")
#define CBC_UNSUPPORTED_KLEN(f) f(110, "Key lenghts above 16 bytes are unsupported")
#define CBC_CANT_KILL_NOTOWN(f) f(111, "Cannot destroy someboy else's io thread")

/* iostream.c error symbols */
#define IOST_SEND_RECV_ONLY(f)  f(121, "Illegal direction arguments (0, or 1 only)")
#define IOST_EEXISTS(f)         f(122, "There has been a layer pushed, already")
#define IOST_NO_RECV_CTLFN(f)   f(123, "There was no receiver control fn, assigned")
#define IOST_NO_RECV_IOLFN(f)   f(124, "There was no receiver input fn, assigned")
#define IOST_NO_SEND_CTLFN(f)   f(125, "There was no sender control fn, assigned")
#define IOST_NO_SEND_IOLFN(f)   f(126, "There was no sender output fn, assigned")

/* elgamal.c error symbols */
#define ELGML_PAYLOAD_ERR(f)	f(131, "No base64 coded response text or key")

/* peks-baseXX.c error symbols */
#define ENC_TEXT_2LONG(f)	f(141, "Conversion text longer than allowed")
#define ENC_B64TEXT_ERR(f)	f(142, "Can't convert text to base 64 numeric (internal)") 
#define ENC_B64EXTR_ERR(f)	f(143, "Can't re-convert numeric to binary text")

/* peks-strings.c error symbols */
#define DECODE_KEY_ERR(f)	f(151, "Can't decode session key message")
#define LINE_KEYLEN_UNDERFLW(f)	f(153, "Key length below the minimum, allowed")
#define LINE_PARSER_B64ERR(f)	f(154, "Some field in the key setup line is not base 64")

/* peks-rpc.c error symbols */
#define PRPC_HEADER_FAILED(f)	f(161, "Received illegal peks/rpc request header")
#define PRPC_COMMD_ILLEGAL(f)	f(162, "Received unexpected peks/rpc command")
#define PRPC_INIT_FAILED(f)	f(163, "Unspecified init error (internal)")
#define PRPC_ALREADY_INIT(f)	f(164, "Descriptor has been initialized, already")
#define PRPC_INT_ARG_ERROR(f)	f(165, "Illegal arguments passed (internal)")

/* peks-rpcdata.c error symbols */
#define PSVC_SIZE_2LARGE(f)	f(171, "Argument size too large for transfer buffer")
#define PSVC_FMT_ERROR(f)	f(172, "Syntax error in argument format specifier")
#define PSVC_FMTSIZE_2LARGE(f)	f(173, "Size overflow in format specifier")
#define PSVC_FMT_NO_TYPE(f)	f(174, "Unknown type letter in format specifier")
#define PSVC_NO_PROTOTYPE(f)	f(175, "No such prpc function prototype")
#define PSVC_ILLCHAR_IN_SVC(f)	f(176, "Illegal character in svc name")
#define PSVC_INT_ARG_ERROR(f)	f(177, "Illegal arguments passed to svc directive (internal)")

/* general text templates */
#define PUBKEY_2SHORT_UU(f)     f(191, "Public key too short (%u), requesting %u bits")
#define PRVKEY_2SHORT_UU(f)     f(192, "Private key too short (%u), requesting %u bits")
#define CANT_SAVE_KEYS_SS(f)    f(193, "Cannot save keys to file %s: %s")
#define CANT_GEN_KEYS_S(f)      f(194, "Cannot generate keys: %s")
#define CANT_READ_KEYS_SS(f)    f(195, "Cannot read keys from file %s: %s")
#define FUNCTION_ARG_ERROR(f)   f(196, "Got illegal function arguments (internal)")

#endif /* __MESSAGES_H__ */
