/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1999
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *   Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: peks-handshake.h,v 1.2 1999/03/31 17:59:55 renaud Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   PEKS - private exponent key stuff for Diffie Hellman and El Gamal
 */

#ifndef __PEKS_HANDSHAKE_H__
#define __PEKS_HANDSHAKE_H__

/* number of bytes sent as a challenge for pub key authentication */
#ifndef AUTH_CHALLENGE_LEN
#define AUTH_CHALLENGE_LEN 30
#endif

extern peks_key *accept_public_key_str (const char *);

extern void update_accepted_public_key_str (peks_key *key);

extern char *make_elg_response_key_str 
  (peks_key *, const char *, unsigned);

extern int accept_challenge_str (peks_key  *key,  const char *in);

extern int  accept_response_key_str (peks_key *, const char *line);

extern char *sign_challenge_str 
  (int type, const char *usr, peks_key *k);

extern char *accept_signed_challenge_str (peks_key *k, const char *line);

extern char *make_digest_challenge_str 
  (peks_key *key, const char *tag, const char *usr, const char *pwd);

extern char *make_challenge_str (peks_key *);

extern int   accept_digest_challenge_str 
  (const peks_key*k, const char *challg, const char*pwd, const char*in);

#endif /* __PEKS_HANDSHAKE_H__ */
