/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1999
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *       Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: peks-svc.h,v 1.2 1999/03/31 17:59:57 renaud Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   PSVC - peks supervisor call for rpc
 */

#ifndef __PEKS_SVC_H__
#define __PEKS_SVC_H__


#ifndef XPUB
#define XPUB /* extract public interface */
#endif

#ifdef __PEKS_INTERNAL_H__


typedef struct _prpc_ftab {
  
  const char         *svc ;	/* the function name */
  void             *plist ;	/* links to particular prototype */ 
  struct _prpc_ftab *next ;	/* next function name */

} prpc_ftab ;


typedef struct _prpc_data {

  int clear_flag ;	/* needs clean up flag */
  
  unsigned size ;	/* data storage area */
  char     *fmt ;
  char    *data ;

  unsigned  left ;	/* retrieve data */
  char   *fmtptr ;
  char  *dataptr ;
  
  void *garbage ;	/* internal garbage collector */

} prpc_data ;

#else
XPUB typedef struct { char opaq [1] ; } prpc_data ;
XPUB typedef struct { char opaq [1] ; } prpc_ftab ;
#endif

XPUB 
XPUB /* public functions in peks-svc.c */
XPUB 
XPUB extern prpc_ftab* psvc_set_proto
XPUB   (prpc_ftab *rpc, int (**Fn)(void*,void**), 
XPUB    const char *svc, const char *fmt, int laxen, void **Env);
XPUB 
XPUB extern prpc_data *psvc_put_longx   (prpc_data*,  long *arg, unsigned dim);
XPUB extern prpc_data *psvc_put_shortx  (prpc_data*, short *arg, unsigned dim);
XPUB extern prpc_data *psvc_put_charx   (prpc_data*,  char *arg, unsigned size);
XPUB extern prpc_data *psvc_put_stringx (prpc_data*, char **arg, unsigned dim);
XPUB extern prpc_data *psvc_put_datax   (prpc_data*, prpc_data *arg, unsigned dim);
XPUB
XPUB extern void psvc_rewind  (prpc_data*);
XPUB extern void psvc_clear   (prpc_data*);
XPUB extern void psvc_destroy (prpc_data*);
XPUB
XPUB extern int   psvc_get_nextx (prpc_data*, void **, unsigned *);
XPUB extern char *psvc_get_proto (prpc_data*);
XPUB extern int   psvc_cmp_proto (prpc_data *, const char *pattern, unsigned laxen);
XPUB
XPUB extern void      *psvc_export   (prpc_data*);
XPUB extern unsigned   psvc_exportlen            (const void *data);
XPUB extern prpc_data *psvc_import   (prpc_data*, const void *data);
XPUB extern prpc_data *psvc_cpy_data (prpc_data*, const prpc_data*);
XPUB
XPUB extern int   psvc_callx (const prpc_ftab*, const char *svc, prpc_data*  args);
XPUB extern void* psvc_call  (const prpc_ftab*, const char *svc, const void* args);
XPUB

#include "cbc-frame.h"

#ifndef MAX_FMT_MULTIPLIER
#define MAX_FMT_MULTIPLIER (CBC_IO_BUFLEN_MAX - 50)
#endif

/* the set of valid chars for an svc name besides 0..9, a..z, A..Z */
#ifndef PSVCNAME_XCHARS
#define PSVCNAME_XCHARS     "_-.@:"
#endif
#ifndef PSVCNAME_NODGTSTART
#define PSVCNAME_NODGTSTART  1    /* an svc name must not start with a digit */
#endif

#endif /* __PEKS_SVC_H__ */
