#include <includes.h>
#include <gtk/gtk.h>
#include "globals.h"
#include "read_target_file.h"
#include "xstuff.h"
void target_file_select()
{
 GtkWidget * file;
 file = gtk_file_selection_new ("Load file");
 gtk_file_selection_set_filename (GTK_FILE_SELECTION(file), "");
 gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (file)->ok_button),
                               "clicked", (GtkSignalFunc) read_target_file,(void *) file );
           
 gtk_signal_connect /*_object*/ (GTK_OBJECT (GTK_FILE_SELECTION
           (file)->cancel_button),
             "clicked", (GtkSignalFunc)close_window, (void *)file);
           
 gtk_widget_show(file);
}


static void
target_file_apply(target)
 char * target;
{
 struct arglist * ctrls = arg_get_value(MainDialog, "TARGET");
 GtkWidget * entry;
 if(!ctrls)return;
 entry = arg_get_value(ctrls, "TARGET");
 if(!entry)return;
 gtk_entry_set_text(GTK_ENTRY(entry), estrdup(target));
}
 

char * target_file_to_list(filename)
 char * filename;
{
 int fd = open(filename, O_RDONLY);
 char * buffer;
 char * ret,*t;
 int len;
 struct stat sb;
 int i = 0;
 if(fd < 0)
 {
  char * text = emalloc(strlen(filename)+300);
  sprintf(text,"Could not open %s\nopen(%s) : %s\n", filename, filename, strerror(errno));
  if(F_quiet_mode)fprintf(stderr, text);
  else show_error(text);
  efree(&text);
  return(NULL);
 }
 fstat(fd, &sb);
 len = sb.st_size;
 
 buffer = mmap(NULL, len, PROT_READ, MAP_PRIVATE, fd, 0);
 if(buffer == MAP_FAILED)
 {
 char * text = emalloc(300);
 sprintf(text, "mmap failed\nmmap : %s\n", strerror(errno));
 if(F_quiet_mode)fprintf(stderr, text);
 else show_error(text);
 efree(&text);
 return(NULL);
 }
 ret = estrdup(buffer);
 munmap(buffer, len);
 t = ret;
 while((t=strchr(t, '\n')))t[0]=',';
 t = ret;
 while((t=strchr(t, '\013')))t[0]=' ';
 i = strlen(ret);
 while(ret[i-1]==','){ret[i-1]='\0';i--;}
 return(ret);
}


 
void
read_target_file(bidon, gtkw)
 GtkWidget * bidon;
 GtkWidget * gtkw;
{
 char * filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(gtkw));
 char * ret = target_file_to_list(filename); 
 target_file_apply(ret);
 efree(&ret);
 gtk_widget_hide(gtkw);
 gtk_widget_destroy(gtkw);
}
