/*
 * Find service
 *
 * This plugin is released under the GPL
 */
 
#include <includes.h>

#define NAME "Services"
#define DESC "This plugin attempts to guess which\n\
service is running on the remote port. For instance,\n\
it searches for a web server which could listen on\n\
another port, and set the results as an PIIC key."
#define COPY "released under the GPL"
#define SUMM "find what is listening on which port"

/*
 * XXX
 * This plugin is highly beta and NOT complete
 *
 */
 
int plugin_init(desc)
 struct arglist * desc;
{ 
 plug_set_name(desc, NAME);
 plug_set_category(desc, ACT_GATHER_INFO);
 plug_set_family(desc, "Misc.");
 plug_set_description(desc, DESC);
 plug_set_summary(desc, SUMM);
 plug_set_copyright(desc, COPY);
 return(0);
}

void mark_http_server(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
   plug_set_key(desc, "Services/www", ARG_INT, (void *)port);
   if(port != 80){
    char * ver;
    char * end;
	
    ver = strstr(buffer, "server:");
    if(ver)ver = strchr(ver, ' ');
    if(ver){
   	char * report;
 	end = strchr(ver, '\n');
	report = emalloc(strlen(ver)+200);
	sprintf(report, "%s is running on this port");
	post_info(desc, port, report);
	efree(&report);
	}
    else post_info(desc, port, "a web server is running on this port");
    }
}

void mark_smtp_server(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 plug_set_key(desc, "Services/smtp", ARG_INT, (void *)port);
 if(port != 25)
 {
  char * report = emalloc(255 + strlen(buffer));
  char *t = strchr(buffer, '\n');
  if(t)t[0]=0;
  sprintf(report, "a SMTP server is running on this port.\n\
Here is its banner : \n%s", buffer);
   post_info(desc, port, report);
   efree(&report);
 }
}

void mark_ftp_server(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 plug_set_key(desc, "Services/ftp", ARG_INT, (void *)port);
 if(port != 21)
 {
  char * report = emalloc(255 + strlen(buffer));
  char *t = strchr(buffer, '\n');
  if(t)t[0]=0;
  sprintf(report, "a FTP server is running on this port.\n\
Here is its banner : \n%s", buffer);
   post_info(desc, port, report);
   efree(&report);
 }
}

void
mark_ssh_server(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 plug_set_key(desc, "Services/ssh", ARG_INT, (void *)port);
 if(port!=22)post_info(desc, port, "a ssh server is running on this port");
}

void
mark_http_proxy(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 plug_set_key(desc, "Services/http_proxy", ARG_INT, (void *)port);
 post_info(desc, port, "an HTTP proxy is running on this port");
}

void
mark_pop_server(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 char * c = strchr(buffer, '\n');
 if(c)c[0]=0;
 if(!strcmp(buffer, "+ok"))
  plug_set_key(desc, "Services/pop1", ARG_INT, (void *)port);
  else if(!strcmp(buffer, "+ok pop2"))
   plug_set_key(desc, "Services/pop2", ARG_INT, (void *)port);
   else
    plug_set_key(desc, "Services/pop3", ARG_INT, (void *)port);
}

void
mark_imap_server(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 plug_set_key(desc, "Services/imap", ARG_INT, (void *)port);
 if(port != 143)post_info(desc, port, "an IMAP server is running on this port");
}

void
mark_linuxconf(desc, port, buffer)
 struct arglist * desc;
 int port;
 char * buffer;
{
 plug_set_key(desc, "Services/linuxconf", ARG_INT, (void *)port);
 post_info(desc, port, "Linuxconf is running on this port");
}
int plugin_run(desc)
 struct arglist * desc;
{
 struct arglist * h = arg_get_value(desc, "HOSTNAME");
 if(!h)return(1);
 h = arg_get_value(h, "PORTS");
 if(!h)return(1);
 /*
  * Search for a web server and stop when one is found
  */
 while(h && h->next)
 {
  int soc;
  char * buffer = emalloc(2048);
  fd_set fd;
  int port = atoi(h->name);
  struct timeval tv = {3,0};
  
  soc = open_sock_tcp(desc, port);
  if(soc >= 0)
  {
   sprintf(buffer, "HEAD / HTTP/1.0\n\n");
   send(soc, buffer, strlen(buffer), 0);
   FD_ZERO(&fd);
   FD_SET(soc, &fd);
   if(select(soc+1, &fd, NULL, NULL, &tv)>0)
   {
    int i;
    int len;
    bzero(buffer, 2000);
    recv(soc, buffer, 2048, 0);
    len = strlen(buffer);
    for(i=0;i<len;i++)buffer[i] = tolower(buffer[i]);
    if(strstr(buffer, "smtp"))
    	mark_smtp_server(desc, port, buffer);
    else if(strstr(buffer, "http")&&strstr(buffer, "200"))
    	mark_http_server(desc, port, buffer);   
    else if(strstr(buffer, "ftp"))
    	mark_ftp_server(desc, port, buffer);	
    else if(strstr(buffer, "ssh"))
    	mark_ssh_server(desc, port, buffer);
    else if(strstr(buffer, "+ok"))
    	mark_pop_server(desc, port, buffer);
    else if(strstr(buffer, "* ok imap4"))
    	mark_imap_server(desc, port, buffer);
    else if(strstr(buffer, "networking/linuxconf"))
        mark_linuxconf(desc, port, buffer);	
    else if(strstr(buffer, "http")&&strstr(buffer, "cache")&&
    	    strstr(buffer, "error"))
	mark_http_proxy(desc, port, buffer);	
   }
   shutdown(soc, 2);
   close(soc);
   efree(&buffer);
   }
  if(h)h = h->next;
  }
 return(0);
}
