/*
 * 
 * hp_remote_print
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h> 


#define NAME "HP Printer Remote Print"
#define DESC "\
HP printers that are configured for remote network printing\n\
list for requests on ports 9099 and 9100. Everyone can then\n\
send data to this port and print it, regardless of the permissions\n\
set on LPD.\n\
This may allow an attacker to disable a printer by flooding it\n\
with requests, which can be a problem when the printer is relied-on\n\
for hard-copy of security auditing logs.\n\
Risk factor : Low/Medium"

#define COPYRIGHT "no copyright"
#define SUMM "checks if anyone can print to the remote printer"


PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Misc.");
	return(0);
}



PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
 int soc;
 char * buf;
 int ports[2] = {9099,9100};
 int i;
 for(i=0;i<2;i++)
 {
 if(host_get_port_state(args, ports[i]))
 {
  soc = open_sock_tcp(args, ports[i]);
  if(soc >= 0)
  post_info(args,ports[i],
"It is possible to connect to this port\n\
If the remote host is an HP printer (which is very likely),\n\
then it means that anyone can print anything on it.\n\
This may allow an attacker to disable a printer by flooding it\n\
with requests, which can be a problem when the printer is relied-on\n\
for hard-copy of security auditing logs.\n\
Solution : filter incoming traffic to this port. If the printer\n\
is booted from network, then it is possible to set up an ACL\n");
  shutdown(soc, 2);
  close(soc);
  }
 }
  return(0);
}


