/*
 * 
 * iis_scripts_browsable
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "IIS /scripts directory browsable"
#define DESC "\
This plugin checks whether the remote server /scripts\n\
directory is browsable or not.\n\
A browsable scripts directory will allow an attacker\n\
to search for potentially vulnerable scripts more\n\
efficiently, and to test your home made scripts too\n\
Risk factor : Medium"
#define COPYRIGHT "distributed under the GPL"
#define SUMM "checks whether the remote /scripts/ directory is browseable"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	plug_set_dep(desc, "find_service.nes");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int port = (int)plug_get_key(args, "Services/www");
	if(!port)port = 80;
	
	if(!host_get_port_state(args, port))return(0);
	else
        {
         int soc = open_sock_tcp(args, port);
         char * buf;
         
         if(soc < 0)return(0);
         buf = emalloc(512);
         sprintf(buf, "GET /scripts/ HTTP/1.0\n\n");
         send(soc, buf, strlen(buf), 0);
         bzero(buf, strlen(buf));
         recv(soc, buf, 511, 0);
         if(strstr(buf, "200")&&strstr(buf, "<title>/scripts"))
         {
          post_hole(args, port, "\
The remote /scripts/ directory appears to\n\
be browsable. This allows an attacker to\n\
search for vulnerable scripts more easily\n\
Solution : deactivate directory listing");
	 }
        efree(&buf);
	}
	return(0);
}

