/*
 * 
 * NetBus Pro
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "NetBus Pro"
#define DESC "\
NetBus Pro is a new version of Netbus which can be\n\
used as a remote administration tool. Due to the past\n\
of this product, it may still be used as a trojan which\n\
allows an intruder to control a Windows system.\n\
This plugin detects if it is installed...\n\
Risk factor : medium/high"
#define COPYRIGHT "no copyright"
#define SUMM "detects if NetBus Pro is running on the remote host"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Backdoors");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{	
	int i;
        
      
	if((host_get_port_state(args, 20034))>0)
	{
	 char * buf = emalloc(4096);
	 char * msg;
	 int soc;
	 
         if(soc = open_sock_tcp(args, 20034)>0)
         {
          recv(soc, buf, 30, 0);
          if(strstr(buf, "NetBus"))
          {
           char * version = strchr(buf, ' ');
           char * end = version?strchr(version+1, ' '):NULL;
           char * report = emalloc(300);
	   int soc2;
           if(end)end[0]=0;
           
	   sprintf(report, 
"NetBus Pro %s is installed on the remote\n\
host. This means that an intruder\n\
can take the control of the remote\n\
host and that it has been compromised.\n\
Solution : see \
http://netbus.org/main.html for instructions about \n\
how to remove it.", version ? version+1:"");
	  post_hole(args, i, report);
          efree(&report);
          }
         }
	shutdown(soc, 2);
	close(soc);
        efree(&buf);
	}
       return(0);
}

