#include <includes.h>
#include <nessusraw.h>
struct pseudo_udp_hdr
{
        struct in_addr saddr;
        struct in_addr daddr;
        char nothing;
	char proto;
	unsigned short len;
};

static unsigned short udp_in_cksum(unsigned short *ptr,int nbytes) {

register long           sum;            /* assumes long == 32 bits */
u_short                 oddbyte;
register u_short        answer;         /* assumes u_short == 16 bits */

/*
 * Our algorithm is simple, using a 32-bit accumulator (sum),
 * we add sequential 16-bit words to it, and at the end, fold back
 * all the carry bits from the top 16 bits into the lower 16 bits.
 */

sum = 0;
while (nbytes > 1)  {
sum += *ptr++;
nbytes -= 2;
}

/* mop up an odd byte, if necessary */
if (nbytes == 1) {
oddbyte = 0;            /* make sure top half is zero */
*((u_char *) &oddbyte) = *(u_char *)ptr;   /* one byte only */
sum += oddbyte;
}

/*
 * Add back carry outs from top 16 bits to low 16 bits.
 */

sum  = (sum >> 16) + (sum & 0xffff);    /* add high-16 to low-16 */
sum += (sum >> 16);                     /* add carry */
answer = ~sum;          /* ones-complement, then truncate to 16 bits */
return(answer);
}

unsigned char * 
forge_udp_packet(source, dest, sport, dport, flags, seq)
 struct in_addr source;
 struct in_addr dest;
 unsigned int sport;
 unsigned int dport;
{
 u_char * ret = emalloc(sizeof(struct ip)+sizeof(struct udphdr));
 struct ip * ip = (struct ip *)ret;
 struct udphdr * udp = (struct udphdr*)(ret + sizeof(struct ip));
 struct pseudo_udp_hdr *pseudo = (struct pseudo_udp_hdr *) ((char *)udp - 12) ;
 
 udp->uh_sport = htons(sport);
 udp->uh_dport = htons(dport);
 udp->uh_ulen  = htons(8);
 
 pseudo->saddr.s_addr = source.s_addr;
 pseudo->daddr.s_addr = dest.s_addr;
 pseudo->proto = IPPROTO_UDP;
 pseudo->len   = htons(sizeof(struct udphdr));
 
#ifdef STUPID_SOLARIS_CHECKSUM_BUG
 udp->uh_sum = sizeof(struct udphdr);
#else
 udp->uh_sum = udp_in_cksum((unsigned short *)pseudo, 20);
#endif
 bzero(pseudo, 12);
 /*
  * Initialize the IP header
  */
 ip->ip_v = 4;
 ip->ip_hl = sizeof(struct ip)/4;
 ip->ip_id = random();
 ip->ip_tos = 0;
 ip->ip_len = FIX(sizeof(struct ip) + sizeof(struct udphdr));
 ip->ip_ttl = 255;
 ip->ip_off = 0;
 ip->ip_p = IPPROTO_UDP;
 ip->ip_src.s_addr = source.s_addr;
 ip->ip_dst.s_addr = dest.s_addr;
 ip->ip_sum = 0;
 ip->ip_sum = udp_in_cksum((short *)ip, sizeof(struct ip));

 return(ret);
}
